<script lang="ts">
  import { createEventDispatcher } from 'svelte';
  import Icon from '@components/Topology/Icon.svelte';
  import server from '@assets/images/topology/server.svg?raw';
  import routerCylinder from '@assets/images/topology/router_cylinder.svg?raw';

  export let icon;
  export let size = '60px';
  export let color = '#808080';
  export let title = 'Unknown Server';
  export let root;
  export let titleLocation = 'top';
  let clazz = '';
  export { clazz as class };

  const dispatch = createEventDispatcher();

  const imgMap = new Map<string, string>([
    ['server', server],
    ['router', routerCylinder],
  ]);
</script>

<div bind:this={root} class="server {clazz}">
  {#if titleLocation == 'top'}
    <p class="server-title p-1 m-1">{title}</p>
  {/if}
  <div class="d-flex flex-row">
    <slot name="before" />
    <Icon data={imgMap.get(icon)} {size} {color} />
    <slot name="after" />
  </div>
  {#if titleLocation == 'bottom'}
    <p class="server-title p-1 m-1">{title}</p>
  {/if}
</div>

<style>
  .server {
    display: flex;
    flex-direction: column;
    align-items: center;
    justify-content: center;
  }

  .server img {
    width: 80px;
  }

  .server-title {
    border-radius: 10px;
    background-color: rgba(0, 0, 0, 0.8);
    white-space: pre;
  }
</style>
